--- e-uae-0.8.29-WIP4/src/gfx-sdl/sdlgfx.c	2007-03-15 06:53:03.000000000 +0100
+++ e-uae-0.8.29-WIP4.kokoold/src/gfx-sdl/sdlgfx.c	2009-03-19 14:53:15.820969454 +0100
@@ -96,7 +96,7 @@
 static int ncolors;
 
 static int fullscreen;
-static int vsync;
+static int vsync = 1;
 static int mousegrab;
 static int mousehack;
 
@@ -203,6 +203,7 @@
     DEBUG_LOG ("Function: init_colors\n");
 
 #ifdef USE_GL
+
     if (currprefs.use_gl) {
         DEBUG_LOG ("SDLGFX: bitdepth = %d\n", bitdepth);
         if (bitdepth <= 8) {
@@ -598,7 +599,9 @@
 
 STATIC_INLINE void sdl_flush_block_nolock (struct vidbuf_description *gfxinfo, int first_line, int last_line)
 {
-   SDL_UpdateRect (display, 0, first_line, current_width, last_line - first_line + 1);
+   //SDL_UpdateRect (display, 0, first_line, current_width, last_line - first_line + 1);
+	//printf("sdl_flush_block_nolock\n");
+
 }
 
 
@@ -665,6 +668,8 @@
 
     sleep_time = uae_gethrtime () - start_time;
     idletime += sleep_time;
+	//printf ("sdl_flush_screen_flip\n");
+	
 }
 
 static void sdl_flush_clear_screen (struct vidbuf_description *gfxinfo)
@@ -675,6 +680,8 @@
 	SDL_Rect rect = { 0, 0, display->w, display->h };
 	SDL_FillRect (display, &rect, SDL_MapRGB (display->format, 0,0,0));
 	SDL_UpdateRect (display, 0, 0, rect.w, rect.h);
+	//printf ("sdl_flush_clear_screen\n");
+
     }
 }
 
@@ -756,8 +763,18 @@
 	write_log ("SDLGFX: Initialized.\n");
 	write_log ("SDLGFX: Using SDL version %d.%d.%d.\n", version->major, version->minor, version->patch);
 
-	/* Find default display depth */
-	bitdepth = info->vfmt->BitsPerPixel;
+
+	/*koko hack: force screen bitdepth: */
+	if (currprefs.gfx_assumebpp_hack > 0) {
+		bitdepth = currprefs.gfx_assumebpp_hack;
+		printf ("koko: Assuming screen bitdepth = %d.\n", bitdepth );
+	} else {
+		/* Find default display depth */
+		bitdepth = info->vfmt->BitsPerPixel;
+		printf ("koko: *NOT* Assuming screen bitdepth = %d.\n", bitdepth);
+		printf ("koko:  = currprefs.gfx_assumebpp_hack = %d.\n", currprefs.gfx_assumebpp_hack );
+	}
+	/*koko hack: end... but what to do with bit_unit? */
 	bit_unit = info->vfmt->BytesPerPixel * 8;
 
 	write_log ("SDLGFX: Display is %d bits deep.\n", bitdepth);
@@ -805,6 +822,7 @@
     SDL_GL_SetAttribute (SDL_GL_DOUBLEBUFFER, 0);
 #endif
 
+
     if (bitdepth <= 16 || (!screen_is_picasso && !(currprefs.chipset_mask & CSMASK_AGA))) {
 	DEBUG_LOG ("Want 16-bit framebuffer.\n");
 	SDL_GL_SetAttribute (SDL_GL_RED_SIZE,   5);
@@ -922,19 +940,26 @@
     Uint32 uiSDLVidModFlags = 0;
 
     DEBUG_LOG ("Function: graphics_subinit\n");
+    printf("Function: graphics_subinit\n");
+
+
+
 
     if (bitdepth == 8)
 	uiSDLVidModFlags |= SDL_HWPALETTE;
     if (fullscreen) {
+	//printf ("enter Fullscreen\n");
 	uiSDLVidModFlags |= SDL_FULLSCREEN | SDL_HWSURFACE;
         if (!screen_is_picasso && currprefs.gfx_vsync)
 	    uiSDLVidModFlags |= SDL_DOUBLEBUF;
+	    //printf ("- Using DoubleBuffer - ");
     }
 
     DEBUG_LOG ("Resolution: %d x %d x %d\n", current_width, current_height, bitdepth);
 
-    screen = SDL_SetVideoMode (current_width, current_height, bitdepth, uiSDLVidModFlags);
 
+
+    screen = SDL_SetVideoMode (current_width, current_height, bitdepth, uiSDLVidModFlags);
     if (screen == NULL) {
 	gui_message ("Unable to set video mode: %s\n", SDL_GetError ());
 	return 0;
@@ -943,13 +968,21 @@
 	fullscreen   = ((screen->flags & SDL_FULLSCREEN) == SDL_FULLSCREEN);
 	is_hwsurface = ((screen->flags & SDL_HWSURFACE)  == SDL_HWSURFACE);
 
+
+	printf("\n");
+	printf("fullscreen?: %d",fullscreen);
+	printf("\n");
+	printf("is_hwsurface: %d",is_hwsurface);
+	printf("\n");
+
+
 	/* We assume that double-buffering is vsynced, but we have no way of
 	 * knowing if it really is. */
 	vsync        = ((screen->flags & SDL_DOUBLEBUF) == SDL_DOUBLEBUF);
 
 	/* Are these values what we expected? */
 #	ifdef PICASSO96
-	    DEBUG_LOG ("P96 screen?    : %d\n", screen_is_picasso);
+	DEBUG_LOG ("P96 screen?    : %d\n", screen_is_picasso);
 #	endif
 	DEBUG_LOG ("Fullscreen?    : %d\n", fullscreen);
 	DEBUG_LOG ("Mouse grabbed? : %d\n", mousegrab);
@@ -970,16 +1003,20 @@
 	}
         gfxvidinfo.flush_clear_screen = sdl_flush_clear_screen;
 
+	vsync = 1;
 
         if (vsync) {
 	    display = SDL_CreateRGBSurface(SDL_HWSURFACE, screen->w, screen->h, screen->format->BitsPerPixel,
 					  screen->format->Rmask, screen->format->Gmask, screen->format->Bmask, 0);
 
 	    gfxvidinfo.flush_screen = sdl_flush_screen_flip;
+		printf("yes, vsync!\n");
 	} else {
 	    display = screen;
 
 	    gfxvidinfo.flush_screen = sdl_flush_screen_dummy;
+		printf("no vsync!\n");
+
 	}
 
 #ifdef PICASSO96
@@ -1068,11 +1105,18 @@
     fullscreen = currprefs.gfx_afullscreen;
     mousegrab = 0;
 
+    current_width  = currprefs.gfx_width_win;
+    current_height = currprefs.gfx_height_win;
+
+    printf("BeforeFixUp: width: %d - height: %d --",current_width, current_height);
+
     fixup_prefs_dimensions (&currprefs);
 
     current_width  = currprefs.gfx_width_win;
     current_height = currprefs.gfx_height_win;
 
+    printf("AfterFixUp: width: %d - height: %d --",current_width, current_height);
+
     if (find_best_mode (&current_width, &current_height, bitdepth, fullscreen)) {
 	gfxvidinfo.width  = current_width;
 	gfxvidinfo.height = current_height;
@@ -1235,6 +1279,8 @@
 # endif /* USE_GL */
 	if (screen_is_picasso && refresh_necessary) {
 	    SDL_UpdateRect (screen, 0, 0, picasso_vidinfo.width, picasso_vidinfo.height);
+	//printf ("handle_events\n");
+
 	    refresh_necessary = 0;
 	    memset (picasso_invalid_lines, 0, sizeof picasso_invalid_lines);
 	} else if (screen_is_picasso && picasso_has_invalid_lines) {
@@ -1271,6 +1317,8 @@
 		    urc++;
 # else
 		    SDL_UpdateRect (screen, 0, strt, picasso_vidinfo.width, i - strt);
+	//printf ("handle_events,OPTIMIZE_UPDATE_RECS\n");
+
 # endif
 		    strt = -1;
 		}
@@ -1279,6 +1327,8 @@
 		abort ();
 # ifdef OPTIMIZE_UPDATE_RECS
 	    SDL_UpdateRects (screen, urc, updaterecs);
+	//printf ("handle_events,OPTIMIZE_UPDATE_RECS\n");
+
 # endif
 	}
 	picasso_has_invalid_lines = 0;
